/* cdfwrite.c
// functions to write PDF1 files from FORTRAN code
*/
#include <stdio.h>
#include <string.h>
#include "copyrght.h"
#include "cdfread.h"

/* pointers for cdf1 files */
FILE * findex;                    /* index */                    
FILE * fnamlib;                   /* name library */
FILE * fdilib;                    /* di library */
FILE * freflib;                   /* ref library */
FILE * fbitmap;                   /* selected bitmap library */

/* Open a bitmap library (.bit) file */
INTEGER4 MSFLAG PS_CREATEBITLIB(
		   const CHAR * filename,  /* name of file */
#ifdef _MSC_VER
		   int FORlen1, /* dummy FORTRAN string length */
#endif
		   const CHAR * diskpath
#ifdef _MSC_VER
		   , int FORlen2 /* dummy FORTRAN string length */
#endif
		   )  /* location of disk files */
{
	char tempname[128];

	/* first try to open the file on disk */
	strcpy(tempname,diskpath);
	strcat(tempname,filename);
	fbitmap = fopen(tempname, "wb");
	if (fbitmap != NULL)  return 0;
	return -1;
}
/* Close the bitmap library file */
void MSFLAG PS_CLOSEBIT(void)
{
  fclose(fbitmap); 
  fbitmap = NULL;
}			

/* write a record to a bitmap library file */
INTEGER4 MSFLAG PS_WRITEBITLIB(
		  INTEGER4 *recpointer, /* sequence # to be written */
		  INTEGER4 *table,      /* bitmap array */
		  INTEGER4 *nentries)   /* number of entries in database */
{
  int i2;
  long bytepointer;
  size_t nwords; 
  
  nwords = (31+*nentries)/32;
  bytepointer = 4 * nwords * (-1 + *recpointer); /* (4*nwords bytes/record) */

  i2 = fseek(fbitmap, bytepointer, SEEK_SET);
  if (i2<0) return -1L;

  i2 = fwrite(table, 4, nwords, fbitmap);
  if (i2<nwords) return -1L;
  return 0L;
}
