C----------------------------------------------------------------------
C	PROGRAM ENCODE
C
C	THIS PROGRAM READS THE SOURCE FILES FOR THE NIST CRYSTAL-DATA 
C       AND CREATES THE FILES NEEDED TO SEARCH THE DATA BASE 
C 
C----------------------------------------------------------------------
C  reads files: 
C       cd_file_location
C       cd-element-symbol
C       IND_cd-id (created by indexfiles)
C
C  creates files: 
C       cd.sizes
C       chem.bit
C       count.bit
C
C----------------------------------------------------------------------
	implicit none
	include 'size.par'
!	include 'pdfread.def'
	include 'cdfwrite.def'
	include 'bitops.def'
	integer Len2ind,ang2ind,rat2ind

C       Assume memory is nearly infinite (CHEM and CELL could share space)
	INTEGER*4 CHEM(max_words,MAX_ELM)
	INTEGER*4 CELLA(max_words,MAX_CELL)
	INTEGER*4 CELLB(max_words,MAX_CELL)
	INTEGER*4 CELLC(max_words,MAX_CELL)
	INTEGER*4 ELCNT(max_words,MAX_ELEMC)
!	INTEGER*4 BITMAP1(max_words)
!	INTEGER*4 BITMAP2(max_words)
!	INTEGER*4 BITMAP3(max_words)

	INTEGER IWORDS,IBYTES
	INTEGER IOPEN,ISEQ,NPAT,ID,id1,NELEM,IDMAX
	INTEGER I,J,K,i1,i2
	CHARACTER*2 ELEM,ELEMS(15)
	CHARACTER*1 matind(4)
C dbloc -- path for cdif input database files (ending in \)
	CHARACTER*80 dbloc,outloc
	CHARACTER*2	ELEMLIST(104)
	CHARACTER*30 MISCLBL(21)
	real         cell(6),volume,x1,x2,x3,rat1,rat2
	real ratio,minratio,maxratio
      DATA ELEMLIST/'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     1'Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca','Sc','Ti','V ',
     2'Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
     3'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In',
     4'Sn','Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','
     5Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re','O
     6s','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn','Fr','Ra',
     7'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md',
     8 'No','Lw','Ln'/
      DATA MISCLBL/'Inorganic materials','Organic materials',
     $     'Minerals','Alloys',
     $     'cell from x-ray diff.','cell from neutron diff.',
     $     'cell from electron diff.','cell from gamma diff.',
     $     'Single xtal measurment','Powder measurment',
     $     'Rietveld analysis',
     $     'Structure not determined','Partial structure determined',
     $     'Complete structure determined',
     $     'Triclinic','Monoclinic','Orthorhombic','Rhombohedral',
     $     'Tetragonal','Hexagonal','Cubic'/
C----------------------------------------------------------------------
	INTEGER LENCH
C=======================================================================
C
C----------------------------------------------------------------------
C DISK/CDROM variables
	write (*,*) 'Beginning program ENCODE'
	open (unit=1, file='cd_file_location', status='old', err=999)
	read(1,'(A)') dbloc
	write (*,*) 'Reading files from location ',dbloc(:lench(dbloc))
	read(1,'(A)') outloc
	write (*,*) 'Writing files to location ',outloc(:lench(outloc))
	close(unit=1)
C Open the input files
C---------------------------------------------------------------------------
C---------------------------------------------------------------------------
C Open the input files
C---------------------------------------------------------------------------
C Open the id index
	iopen = 1
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    ACCESS='DIRECT',RECL=4,FORM='UNFORMATTED',
	1    FILE=outloc(:lench(outloc))//'IND_cd-id')


C---------------------------------------------------------------------------
C Open the element symbols
	iopen = 21
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    FILE=dbloc(:lench(dbloc))//'cd-element-symbol')
C---------------------------------------------------------------------------
C Initialization
C---------------------------------------------------------------------------
C zero out the bitmaps
	DO I=1, MAX_ELM
	  DO J = 1, max_words
	    CHEM(J,I) = 0
	  ENDDO
	ENDDO
	DO I = 1, MAX_ELEMC
	  DO J = 1, max_words
	    ELCNT(J,I) = 0
	  ENDDO
	ENDDO
C restart the id index
	ISEQ = 0

 1	READ(21,'(1x,I6,2x,I2,1X,15(a2,2x))',end=91)
	1    ID,NELEM,(ELEMS(I),I=1,MIN(NELEM,15))
	ID1 = 0
	DO WHILE (ID1 .LT. ID) 
	   ISEQ = ISEQ + 1
	   READ(1,rec=ISEQ) ID1
	ENDDO
	IF (ID .NE. ID1) then
	   write (*,*) 'sequence error',iseq,id,id1
	   stop
	endif
C   Set the bit(s) for the subfile indices
C	IWRD=(ISEQ-1)/32 + 1
C	IBIT=MOD(ISEQ-1,32)
C   Set the appropriate bits in the element bitmap array
	DO I=1,MIN(NELEM,15)
	   elem = elems(i)
	   if (ICHAR(ELEM(2:2)) .LT. ICHAR('A')) ELEM(2:2) = ' '
	   if (ELEM .EQ. 'D ') ELEM = 'H '
	   if (ELEM .EQ. 'T ') ELEM = 'H '
	   DO J=1,104
	      IF (ELEMLIST(j) .EQ. ELEM) THEN
		 K = J
		 GOTO 11
	      ENDIF
	   ENDDO
	   WRITE(*,*) 'Unknown element, ID=',ID,' ELEM=',ELEMS(I),
	1	ICHAR(ELEM(2:2))
	   GOTO 12
 11	   CALL tblbitset(CHEM(1,K), ISEQ, ISEQ, 1)
	   IF (K .ge. 57 .and. K .le. 71)
	1	CALL tblbitset(CHEM(1,104), ISEQ, ISEQ, 1)
	ENDDO
 12	NELEM = MIN(MAX_ELEMC,NELEM)
	IF (NELEM .GT. 0) THEN
	   CALL tblbitset(ELCNT(1,NELEM), ISEQ, ISEQ, 1)  
	ELSE
	   WRITE(*,*) 'Bad element count NELEM=',NELEM
	ENDIF
	goto 1
C done processing all entries
 91	continue
C now write out bitmaps
	NPAT = ISEQ
	Iwords = (ISEQ-1)/32 + 1
	Ibytes = Iwords * 4
	WRITE(6,1602) iseq
1602	FORMAT (//'Total patterns processed:',I7,/,
     1	/,' Number of patterns by element')
	i = ps_createbitlib('chem.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating chem.bit'

	DO I=1,104
	   k = ps_writebitlib(i, CHEM(1,i), npat)
	   if (k .ne. 0) write (*,*) 'Error on CHEM bitmap write',k
	   k = tblcount(chem(1,i), npat)
	   write (*,'(i8,i5,1x,A)') K,I,ELEMLIST(I)
	enddo
	CALL ps_closebit
	WRITE(6,'(/A)') ' Number of patterns by element count'
	i = ps_createbitlib('count.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating count.bit'
	DO I=1,MAX_ELEMC
	   k = ps_writebitlib(i, ELCNT(1,i), npat)
	   if (k .ne. 0) write (*,*) 'Error on count bitmap write',k
	   k = tblcount(elcnt(1,i), npat)
	   write (*,'(i8,i3,A)') K,I
	enddo
	CALL ps_closebit

C++++++++++++++++++++++++++++++++++++++++++++++++++
C zero out the bitmaps
	DO I=1, MAX_ELM
	  DO J = 1, max_words
	    CHEM(J,I) = 0
	  ENDDO
	ENDDO

C Open the materials info
	iopen = 22
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    FILE=dbloc(:lench(dbloc))//'cd-materials-indicators')
C restart the id index
	ISEQ = 0

 2	READ(22,'(1x,I6,3x,4A1)',end=92) id,matind
	ID1 = 0
	DO WHILE (ID1 .LT. ID) 
	   ISEQ = ISEQ + 1
	   READ(1,rec=ISEQ) ID1
	ENDDO
	IF (ID .NE. ID1) then
	   write (*,*) 'cd-materials-indicators sequence error',
	1	iseq,id,id1
	   stop
	endif
	if (matind(1) .eq. 'I') THEN
	   CALL tblbitset(CHEM(1,1), ISEQ, ISEQ, 1)
	elseif (matind(1) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-materials-indicators',id,matind(1),1
	endif
	if (matind(2) .eq. 'O') THEN
	   CALL tblbitset(CHEM(1,2), ISEQ, ISEQ, 1)
	elseif (matind(2) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-materials-indicators',id,matind(2),2
	endif
	if (matind(3) .eq. 'M') THEN
	   CALL tblbitset(CHEM(1,3), ISEQ, ISEQ, 1)
	elseif (matind(3) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-materials-indicators',id,matind(3),3
	endif
	if (matind(4) .eq. 'A') THEN
	   CALL tblbitset(CHEM(1,4), ISEQ, ISEQ, 1)
	elseif (matind(4) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-materials-indicators',id,matind(4),4
	endif
	goto 2

C Open the experimental conditions
 92	iopen = 23
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    FILE=dbloc(:lench(dbloc))//'cd-authors-parameters-I')
C restart the id index
	ISEQ = 0

 4	READ(23,'(1x,I6,T75,3(A1,1x),T84,A1)',end=94) id,matind
	ID1 = 0
	DO WHILE (ID1 .LT. ID) 
	   ISEQ = ISEQ + 1
	   READ(1,rec=ISEQ) ID1
	ENDDO
	IF (ID .NE. ID1) then
	   write (*,*) 'cd-authors-parameters-I sequence error',
	1	iseq,id,id1
	   stop
	endif
C Radiation
	if (matind(1) .eq. 'X') THEN
	   CALL tblbitset(CHEM(1,5), ISEQ, ISEQ, 1)
	elseif (matind(1) .eq. 'N') THEN
	   CALL tblbitset(CHEM(1,6), ISEQ, ISEQ, 1)
	elseif (matind(1) .eq. 'E') THEN
	   CALL tblbitset(CHEM(1,7), ISEQ, ISEQ, 1)
	elseif (matind(1) .eq. 'G') THEN
	   CALL tblbitset(CHEM(1,8), ISEQ, ISEQ, 1)
	elseif (matind(1) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-authors-parameters-I 1',id,matind(1)
	endif
C Study type
	if (matind(2) .eq. 'S') THEN
	   CALL tblbitset(CHEM(1,9), ISEQ, ISEQ, 1)
	elseif (matind(2) .eq. 'P') THEN
	   CALL tblbitset(CHEM(1,10), ISEQ, ISEQ, 1)
	elseif (matind(2) .eq. 'R') THEN
	   CALL tblbitset(CHEM(1,11), ISEQ, ISEQ, 1)
	elseif (matind(2) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-authors-parameters-I 2',id,matind(2)
	endif
C Structure code 
	if (matind(3) .eq. 'N') THEN
	   CALL tblbitset(CHEM(1,12), ISEQ, ISEQ, 1)
	elseif (matind(3) .eq. 'L') THEN
	   CALL tblbitset(CHEM(1,13), ISEQ, ISEQ, 1)
	elseif (matind(3) .eq. 'T') THEN
	   CALL tblbitset(CHEM(1,14), ISEQ, ISEQ, 1)
	elseif (matind(3) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-authors-parameters-I 3',id,matind(3)
	endif
C Crystal System
	if (matind(4) .eq. 'A') THEN
	   CALL tblbitset(CHEM(1,15), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'M') THEN
	   CALL tblbitset(CHEM(1,16), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'O') THEN
	   CALL tblbitset(CHEM(1,17), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'R') THEN
	   CALL tblbitset(CHEM(1,18), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'T') THEN
	   CALL tblbitset(CHEM(1,19), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'H') THEN
	   CALL tblbitset(CHEM(1,20), ISEQ, ISEQ, 1)
	elseif (matind(4) .eq. 'C') THEN
	   CALL tblbitset(CHEM(1,21), ISEQ, ISEQ, 1)
	elseif (matind(4) .ne. ' ') THEN
	   write (*,*) 'Invalid cd-authors-parameters-I 4',id,matind(4)
	endif

	goto 4
C now write out bitmaps
 94	close(unit=22)
	i = ps_createbitlib('misc.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating misc.bit'
	WRITE(6,'(/A)') ' Number of patterns by entry type'
	DO I=1,21
	   k = ps_writebitlib(i, CHEM(1,i), npat)
	   if (k .ne. 0) write (*,*) 'Error on MISC bitmap write',k
	   k = tblcount(chem(1,i), npat)
	   write (*,'(i8,i5,1x,A)') K,I,MISCLBL(I)
	ENDDO
	CALL ps_closebit
C++++++++++++++++++++++++++++++++++++++++++++++++++
C zero out the bitmaps
	DO I=1, MAX_CELL
	  DO J = 1, max_words
	    CELLA(J,I) = 0
	    CELLB(J,I) = 0
	    CELLC(J,I) = 0
	  ENDDO
	ENDDO
C Open the reduced cell 
	iopen = 24
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    FILE=dbloc(:lench(dbloc))//'cd-reduced-parameters-I')
C
C restart the id index
	ISEQ = 0
 5	READ(24,'(1x,I6,3x,3f8.0,3f7.0,f9.0)',end=95) id,cell,volume
	ISEQ = ISEQ + 1
	READ(1,rec=ISEQ) ID1
	if (ID1 .LT. ID) THEN
	   write (*,*) 'Read ',ID,' expecting ',id1
	   Stop 'Missing ID'
	endif

	CALL tblbitset(CELLA(1,Len2ind(cell(1))), ISEQ, ISEQ, 1)
	CALL tblbitset(CELLB(1,Len2ind(cell(2))), ISEQ, ISEQ, 1)
	CALL tblbitset(CELLC(1,Len2ind(cell(3))), ISEQ, ISEQ, 1)

	GOTO 5
 95	i = ps_createbitlib('cella.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cella.bit'
	DO I=1,MAX_CELL
	   k = ps_writebitlib(i, CELLA(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	i = ps_createbitlib('cellb.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cellb.bit'
	DO I=1,MAX_CELL
	   k = ps_writebitlib(i, CELLB(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	i = ps_createbitlib('cellc.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cellc.bit'
	DO I=1,MAX_CELL
	   k = ps_writebitlib(i, CELLC(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	write (*,'(A)') ' ','entries by Reduced Cell Length'
	write (*,'(8x,3a5,3a9)') '  a','  b','  c',
	1    '   min','  avg','  max'

	DO I=1,MAX_CELL
	   call ind2Len(i,x1,x2,x3)
	   write (*,'(i8,3i5,3F9.3)') i,
	1	tblcount(cella(1,i), npat),
	1	tblcount(cellb(1,i), npat),tblcount(cellc(1,i), npat),
	2	x2,x1,x3
	ENDDO

C restart the reduced cell file
	rewind(unit=24)
C zero out the bitmaps
	DO I=1, MAX_ANG
	  DO J = 1, max_words
	    CELLA(J,I) = 0
	    CELLB(J,I) = 0
	    CELLC(J,I) = 0
	  ENDDO
	ENDDO
C restart the id index
	ISEQ = 0
 6	READ(24,'(1x,I6,3x,3f8.0,3f7.0,f9.0)',end=96) id,cell,volume
	ISEQ = ISEQ + 1
	READ(1,rec=ISEQ) ID1
	if (ID1 .LT. ID) THEN
	   write (*,*) 'Read ',ID,' expecting ',id1
	   Stop 'Missing ID'
	endif

	CALL tblbitset(CELLA(1,ang2ind(cell(4))), ISEQ, ISEQ, 1)
	CALL tblbitset(CELLB(1,ang2ind(cell(5))), ISEQ, ISEQ, 1)
	CALL tblbitset(CELLC(1,ang2ind(cell(6))), ISEQ, ISEQ, 1)

	GOTO 6
 96	i = ps_createbitlib('cellalpha.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cellalpha.bit'
	DO I=1,MAX_ANG
	   k = ps_writebitlib(i, CELLA(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	i = ps_createbitlib('cellbeta.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cellbeta.bit'
	DO I=1,MAX_ANG
	   k = ps_writebitlib(i, CELLB(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	i = ps_createbitlib('cellgamma.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating cellgamma.bit'
	DO I=1,MAX_ANG
	   k = ps_writebitlib(i, CELLC(1,i), npat)	   
	ENDDO
	CALL ps_closebit
	write (*,'(A)') ' ','entries by Reduced Cell angles'
	write (*,'(8x,3a8,3a9)') 'alpha',' beta',' gamma',
	1    '   min','  avg','  max'

	DO I=1,MAX_ANG
	   call ind2ang(i,x1,x2,x3)
	   write (*,'(i8,3i8,3F9.3)') i,
	1	tblcount(cella(1,i), npat),
	1	tblcount(cellb(1,i), npat),tblcount(cellc(1,i), npat),
	2	x2,x1,x3
	ENDDO

	close(unit=24)
C---------------------------------------------------------------------------
C Open the cell ratios
	iopen = 20
	OPEN(UNIT=iopen,STATUS='OLD',err=1000,
	1    FILE=dbloc(:lench(dbloc))//'cd-CrystalData-parameters-I')
C zero the arrays
	DO I=1, MAXRAT_1+MAXRAT_2
	  DO J = 1, max_words
	    CHEM(J,I) = 0
	  ENDDO
	ENDDO

	IDMAX = 0
C restart the id index
	ISEQ = 0
 8	read(iopen,'(i7,49x,2f9.0)',end=98) id,rat1,rat2
	IDMAX = MAX(IDMAX,ID)
	ID1 = 0
	DO WHILE (ID1 .LT. ID) 
	   ISEQ = ISEQ + 1
	   READ(1,rec=ISEQ) ID1
	ENDDO
	IF (ID .NE. ID1) then
	   write (*,*) 'sequence error',iseq,id,id1
	   stop
	endif
	i = Rat2ind(rat1,1)
	CALL tblbitset(CHEM(1,i), ISEQ, ISEQ, 1)
	if (rat2 .gt. 0) then
	   i = Rat2ind(rat2,2)
	   CALL tblbitset(CHEM(1,MAXRAT_1+i), ISEQ, ISEQ, 1)
	endif
	goto 8
 98	close(unit=20)
	i = ps_createbitlib('ratio1.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating ratio1.bit'
	DO I=1,MAXRAT_1
	   k = ps_writebitlib(i, CHEM(1,i), npat)
	   if (k .ne. 0) write (*,*) 'Error on Ratio1 bitmap write',k
	ENDDO
	CALL ps_closebit
	i = ps_createbitlib('ratio2.bit'//char(0),
	1    outloc(:lench(outloc))//char(0))
	if (i .ne. 0) stop 'error creating ratio2.bit'
	DO I=1, MAXRAT_2
	   k = ps_writebitlib(i, CHEM(1,i+MAXRAT_1), npat)
	   if (k .ne. 0) write (*,*) 'Error on Ratio2 bitmap write',k
	ENDDO
	CALL ps_closebit

	write (*,'(A)') ' ','entries by cell ratios'
	write (*,'(6x,2a8,3a10)') 'ratio 1',' ratio 2',
	1    '   min','  avg','  max'
	do I=1,MAXRAT_2
	   i1 = tblcount(chem(1,i), npat)
	   i2 = tblcount(chem(1,i+MAXRAT_1), npat)
	   call ind2rat(i,ratio,minratio,maxratio,2)
	   write (*,'(i6,2i8,3f10.3)')i,i1,i2,minratio,ratio,maxratio
	enddo
	do I=MAXRAT_2+1,MAXRAT_1
	   i1 = tblcount(chem(1,i), npat)
	   call ind2rat(i,ratio,minratio,maxratio,1)
	   write (*,'(i6,i8,8x,3f10.3)')i,i1,minratio,ratio,maxratio
	enddo
C++++++++++++++++++++++++++++++++++++++++++++++++++
	close(unit=1)
C write the actual number of entries in the CD database 
	OPEN (UNIT=1,FILE=outloc(:lench(outloc))//'cd.sizes',
     1		STATUS='UNKNOWN')
	WRITE (1,*) npat, idmax, max_elemc, max_cell
	CLOSE (UNIT=1)
C----------------------------------------------------------------------
	write (*,*) 'Program ENCODE Complete'
	STOP
 1000	WRITE(*,*) 'Error on open for unit', iopen
	stop
 999	write (*,*) 'File cd_file_location not found'
	END
