#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* This code assumes that there is a reduced cell entry for every  */
/* entry in the database  */

int main (void) {
  int indexfile (char * outpath, char * inpath, char * filename);
  char inpath[128];
  char outpath[128];
  char tempname[128];
  char line[128];
  FILE * filep;
  FILE * cdin;
  FILE * cdind;
  FILE * idind;
  long pos,id;
  printf("Beginning program indexfiles\n");

  filep = fopen("cd_file_location", "r");
  if (filep == NULL) {
    fputs("file cd_file_location not found\n", stderr);
    return 1;
  }
  if (fscanf(filep, "%s", inpath) != 1) /* location of cdrom files */
      return 2;
  if (fscanf(filep, "%s", outpath) != 1) /* location of disk files */
      return 3;
  fclose(filep);

  strcpy(tempname,inpath);
  strcat(tempname, "cd-reduced-parameters-I");
  cdin = fopen(tempname, "r");
  if (cdin == NULL) return 4;

  strcpy(tempname,outpath);
  strcat(tempname, "IND_cd-reduced-parameters-I");
  cdind = fopen(tempname, "w");
  if (cdind == NULL) return 5;

  strcpy(tempname,outpath);
  strcat(tempname, "IND_cd-id");
  idind = fopen(tempname, "w");
  if (idind == NULL) return 5;

  pos = ftell(cdin);
  while (fgets(line, 128, cdin) != NULL) 
    {
      sscanf(line, "%ld", &id); 
      fwrite(&id, 4, 1,  idind); 
      fwrite(&pos, 4, 1,  cdind); 
      /* printf ("pos = %ld  id = %ld\n",pos, id ); */
      pos = ftell(cdin);
    }
  fclose(cdin);
  fclose(cdind);
  fclose(idind);
  indexfile(outpath, inpath, "cd-compound-name");
  indexfile(outpath, inpath, "cd-chemical-formula");
  indexfile(outpath, inpath, "cd-empirical-formula");
  indexfile(outpath, inpath, "cd-literature-reference");
  indexfile(outpath, inpath, "cd-comments");
  indexfile(outpath, inpath, "cd-authors-parameters-I");
  indexfile(outpath, inpath, "cd-authors-parameters-II");
  indexfile(outpath, inpath, "cd-authors-parameters-III");
  indexfile(outpath, inpath, "cd-CrystalData-parameters-I");
  indexfile(outpath, inpath, "cd-CrystalData-parameters-II");
  indexfile(outpath, inpath, "cd-materials-indicators");
  indexfile(outpath, inpath, "cd-processing-I");
  indexfile(outpath, inpath, "cd-processing-II");
  indexfile(outpath, inpath, "cd-structure-type");
  indexfile(outpath, inpath, "cd-transformation");
  printf("\nProgram indexfiles complete\n\n\n");
  return 0;
}

int indexfile (char * outpath, char * inpath, char * filename) {
  FILE * cdin;
  FILE * cdind;
  FILE * idind;
  char tempname[128];
  char line[128];
  long id,pos,cdid,mt;

  printf("Processing file %s\n", filename);
  mt = -1;
  /* open the sequence # file read-only */
  strcpy(tempname,outpath);
  strcat(tempname, "IND_cd-id");
  idind = fopen(tempname, "r");

  strcpy(tempname,outpath);
  strcat(tempname, "IND_");
  strcat(tempname, filename);
  cdind = fopen(tempname, "w");
  if (cdind == NULL) return 5;

  strcpy(tempname,inpath);
  strcat(tempname, filename);
  cdin = fopen(tempname, "r");
  if (cdin == NULL) return 4;

  /*  get the first entry   */
  pos = ftell(cdin);
  if (fgets(line, 128, cdin) == NULL) {
    fprintf(stderr," no records on file %s\n", filename);
    return 9;
  }
  sscanf(line, "%ld", &cdid); 

  fseek(idind, 0, SEEK_SET);
  while (fread(&id, 4, 1,  idind) != 0 && cdid > 0) {
    /*  printf ("id = %ld\n",id ); */
    while (cdid < id) {
      /*  printf ("skip id = %ld %s\n",cdid,line ); */
      pos = ftell(cdin);
      if (fgets(line, 128, cdin) == NULL) {
	cdid = -1;
	break;
      }
      sscanf(line, "%ld", &cdid); 
    }
    if (cdid > id) {
      /* flag as not present (-1) */
      fwrite(&mt, 4, 1,  cdind);      
      /*  printf ("no entry found for id = %ld\n",id ); */
    } else {
      /*  printf ("matched id = %ld with %ld %s\n",id,cdid,line ); */
      fwrite(&pos, 4, 1,  cdind); 
    }
  }
  fclose(cdin);
  fclose(cdind);
  fclose(idind);
  return 0;
}
