      SUBROUTINE DETERM
      COMMON /ERR2/ IERR2
      COMMON /FCN1/ IFCN
      COMMON /MATR1/ U1,V1,W1,U2,V2,W2,U3,V3,W3
      COMMON /UNIT2/ IUNITB
C
C
C     SUBROUTINE 'DETERM' ...
C        CALCULATE THE DETERMINANT OF A 3 BY 3 MATRIX
C        TO CHECK FOR VALID INPUT MATRIX
C
C
C
C     --- INITIALIZE VARIABLES
      DET = 0
      IERR2 = 0
C
C     --- CALCULATE DETERMINANT
      DET = U1*V2*W3 + V1*W2*U3 + W1*U2*V3 - U3*V2*W1 - V3*W2*U1 -
     $      W3*U2*V1
C
C     --- CHECK VALUE OF DETERMINANT FOR ERROR OR WARNING
C         SITUATIONS (DIFFERENT ACTIONS ARE REQUIRED FOR
C         DIFFERENT PROGRAM FUNCTIONS)
      IF(.NOT.(IFCN.EQ.2.OR.IFCN.EQ.6)) GO TO 100
C
C        --- RSS, SYM (R,R1 OPTION) PROGRAM FUNCTIONS ARE
C            BEING EXECUTED
C
C        --- FOR ZERO OR NEGATIVE DETERMINANT, STOP PROGRAM
C            EXECUTION (SHOULD NOT OCCUR)
         IF(DET.LE.0.01) STOP
     $      '*DETERM* ERROR ... Determinant is zero or negative.'
C
C        --- FOR DETERMINANTS GREATER THAN 9, STOP PROGRAM
C            EXECUTION (SHOULD NOT OCCUR)
         IF(DET.GE.9.01) STOP
     $      '*DETERM* ERROR ... Determinant is greater than nine.'
         GO TO 400
  100 CONTINUE
      IF(.NOT.(IFCN.EQ.3.OR.IFCN.EQ.4)) GO TO 200
C
C        --- TRANS,INV PROGRAM FUNCTIONS ARE BEING EXECUTED
C
C        --- FOR NEGATIVE DETERMINANT, WRITE WARNING AND CONTINUE
         IF(DET.LT.-0.01) WRITE(IUNITB,6000)
C
C        --- FOR ZERO DETERMINANT, SET ERROR FLAG
C            (DO NOT HAVE A VALID MATRIX)
         IF(DET.GE.-0.01.AND.DET.LE.0.01) IERR2 = 1
C
C        --- FOR DETERMINANTS >= 100 OR <= -100, SET ERROR FLAG
C            (DO NOT HAVE A VALID MATRIX)
         IF(ABS(DET).GE.100.0) IERR2 = 1
         GO TO 400
  200 CONTINUE
C
C     --- STOP PROGRAM EXECUTION SINCE A VALID PROGRAM FUNCTION
C         HAS NOT BEEN ENCOUNTERED (SHOULD NOT OCCUR)
      STOP '*DETERM* ERROR ... Invalid progam function.'
  400 CONTINUE
      RETURN
 6000 FORMAT(/1X,'*DETERM* WARNING ... Determinant of matrix is negative
     $.'/)
      END
