      SUBROUTINE OUTPT2(IFLAG3)
      COMMON /HCELL1/ YA,YB,YC,YAL,YBE,YGA,YV
      COMMON /HCELL2/ ZA,ZB,ZC,ZAL,ZBE,ZGA,ZV
      COMMON /HDET1/ HDET
      COMMON /HELEM1/ NHEL
      COMMON /HELEM2/ HEL(99)
      COMMON /HTOL1/ TOLI1,TOLI2,TOLI3,TOLI4,TOLI5,TOLI6
      COMMON /HTOL2/ TOLA,TOLB,TOLC,TOLAL,TOLBE,TOLGA
      COMMON /INVER1/ UI1,VI1,WI1,UI2,VI2,WI2,UI3,VI3,WI3
      COMMON /MATR1/ U1,V1,W1,U2,V2,W2,U3,V3,W3
      COMMON /PROB1/ NTD,IPROB
      COMMON /UNIT2/ IUNITB
C
C
C     SUBROUTINE 'OUTPT2' ...
C          OUTPUT FOR PROGRAM (REL,SYM FUNCTIONS)
C
C
C
C     --- CHECK FOR VALID SECTION OF OUTPUT (IF NOT VALID,
C         WRITE ERROR MESSAGE AND STOP EXECUTION OF PROGRAM)
      IF(IFLAG3.LT.1.OR.IFLAG3.GT.11)
     $STOP '*OUTPT2* ERROR ... Invalid value of IFLAG3 generated.'
C
C     --- GO TO APPROPRIATE SECTION OF OUTPUT (INDICATED BY IFLAG3)
      GO TO (10,20,30,40,50,60,70,80,90,100,110) IFLAG3
   10 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- HEADING FOR RELATE TWO LATTICES VIA THE CONVERSE-TRANSFORM
      WRITE(IUNITB,6100)
      GO TO 900
   20 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- WRITE INPUT TOLERANCES AND POSSIBLE MATRIX ELEMENTS
      WRITE(IUNITB,6300) TOLI1,TOLI2,TOLI3,TOLI4,TOLI5,TOLI6
      WRITE(IUNITB,6400)
      WRITE(IUNITB,6500) (HEL(K),K=1,NHEL)
      GO TO 900
   30 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- SUB-HEADING FOR LATTICE GROUP
      WRITE(IUNITB,6600) IPROB
      GO TO 900
   40 CONTINUE
C
C     --- INVALID VALUE OF IFLAG3 GENERATED, STOP PROGRAM
C         EXECUTION (SHOULD NOT OCCUR)
      STOP '*OUTPT2* ERROR ... Invalid value of IFLAG3 generated.'
   50 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- WRITE INPUT CELLS AND CALCULATED CELL VOLUMES
      WRITE(IUNITB,6700) YA,YB,YC,YAL,YBE,YGA,YV
      WRITE(IUNITB,6800) ZA,ZB,ZC,ZAL,ZBE,ZGA,ZV
      GO TO 900
   60 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- WRITE COLUMN HEADING FOR OUTPUT
      WRITE(IUNITB,6900)
      WRITE(IUNITB,7000)
      WRITE(IUNITB,6900)
      WRITE(IUNITB,9020)
      GO TO 900
   70 CONTINUE
C
C     *** CALLED FROM 'HMATRX'
C
C        --- WRITE MATRIX AND INVERSE, TOLERANCES, DETERMINANT
         WRITE(IUNITB,7100) U1,V1,W1,UI1,VI1,WI1,TOLA, TOLB, TOLC, HDET
         WRITE(IUNITB,7100) U2,V2,W2,UI2,VI2,WI2,TOLAL,TOLBE,TOLGA
         WRITE(IUNITB,7100) U3,V3,W3,UI3,VI3,WI3
         WRITE(IUNITB,9020)
      GO TO 900
   80 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- WRITE OUTPUT INDICATING END OF PROBLEM
      WRITE(IUNITB,6900)
      GO TO 900
   90 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- HEADING FOR SYM DET THROUGH CT ANALYSIS
      WRITE(IUNITB,7200)
      GO TO 900
  100 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- SUB-HEADING FOR SYMMETRY
      WRITE(IUNITB,7300) IPROB
      GO TO 900
  110 CONTINUE
C
C     *** CALLED FROM 'LATTIC'
C
C     --- WRITE INPUT CELL AND CALCULATED CELL VOLUME
      WRITE(IUNITB,6700) YA,YB,YC,YAL,YBE,YGA,YV
      WRITE(IUNITB,9020)
      GO TO 900
  900 CONTINUE
      RETURN
 6100 FORMAT(////1X,10X,'RELATE TWO LATTICES via the Converse-Transform'
     $,T80,'U.S. Patent Pending (To be published).'/
     $1X,T80,'Karen, V.L. and Mighell, A.D.')
 6300 FORMAT(////1X,'Input Tolerances are :'//1X,5X,6F10.4)
 6400 FORMAT(////1X,'Possible Matrix Elements include :')
 6500 FORMAT(1H0,5X,10F10.4)
 6600 FORMAT(1H1,////34X,'**  Lattice Group ',I3,' **'//)
 6700 FORMAT(1X,'CELL  1=',3F10.4,1X,3F10.3,14X,'V1=',F10.2)
 6800 FORMAT(1X,'CELL  2=',3F10.4,1X,3F10.3,14X,'V2=',F10.2//)
 6900 FORMAT(1X,130(1H-))
 7000 FORMAT(1X,T14,'H Matrix',T52,'Inverse Matrix',T91,'Tolerance Matri
     $x',T121,'Determinant')
 7100 FORMAT(1X,3F10.4,10X,3F10.4,10X,3F10.4,10X,F10.4)
 7200 FORMAT(////1X, 9X,'SYMMETRY DETERMINATION through Converse-Transfo
     $rmation analysis',T80,
     $'Acta Cryst. (1987). A43, 375-384.'/
     $1X,T80,'Karen (Himes), V.L. and Mighell, A.D.')
 7300 FORMAT(1H1,////36X,'**  Symmetry ',I3,' **'//)
 9020 FORMAT(//)
      END
