      SUBROUTINE RD061
      CHARACTER AELECD,AHI,AHR
      COMMON /HELEM1/ NHEL
      COMMON /HELEM2/ HEL(99)
      COMMON /HOPT1/ IRSYM
      COMMON /HTOL1/ TOLI1,TOLI2,TOLI3,TOLI4,TOLI5,TOLI6
      COMMON /PRINT1/ IPRRSS
C
      COMMON /UNIT1/ IUNITA
      COMMON /UNIT2/ IUNITB
      DATA AHI/'I'/, AHR/'R'/
C
C
C     SUBROUTINE 'RD061' ...
C        READS AND INTERPRETS SYM LINE
C        (ALSO GENERATES POSSIBLE MATRIX ELEMENTS)
C
C
C
C     --- INITIALIZE VARIABLES
      IRSYM  = 0
      IPRRSS = 0
C
C     --- READ SYM LINE
C         (MATRIX ELEMENT CODE, RSS PRINT OPTION,
C          MATRIX RANGE, INPUT TOLERANCES)
      READ(IUNITA,6200) AELECD,IPRRSS,IRANGE,
     $ TOLI1,TOLI2,TOLI3,TOLI4,TOLI5,TOLI6
C
C     --- IF NOT VALID MATRIX ELEMENT CODE, WRITE ERROR MESSAGE AND
C         STOP PROGRAM EXECUTION
      IF(AELECD.EQ.AHI.OR.AELECD.EQ.AHR) GO TO 100
         WRITE(IUNITB,6300)
         STOP
  100 CONTINUE
C
  200 CONTINUE
C
C     --- IF INTEGER RANGE IS NOT USED TO SPECIFY POSSIBLE
C         MATRIX ELEMENTS, R,R1 OPTION IS USED
      IF(AELECD.NE.AHI) GO TO 380
C
C        --- INTEGER RANGE IS USED TO SPECIFY POSSIBLE MATRIX ELEMENTS
         IF(IRANGE.GE.1.AND.IRANGE.LE.40) GO TO 220
C
C           --- INVALID RANGE OF POSSIBLE MATRIX ELEMENTS,
C               WRITE ERROR MESSAGE AND STOP PROGRAM EXECUTION
             WRITE(IUNITB,6500)
             STOP
  220    CONTINUE
C
C        --- GENERATE INTEGER MATRIX ELEMENTS
         NHEL = 2*IRANGE + 1
         IRANGE = (-1)*IRANGE
         DO 320 I = 1,NHEL
            HEL(I) = IRANGE
            IRANGE = IRANGE + 1
  320    CONTINUE
         IRANGE = 0
         GO TO 600
  380 CONTINUE
C
C     --- R,R1 OPTION IS USED TO SPECIFY POSSIBLE MATRIX ELEMENTS
C
      IRSYM = 1
      IRANGE = 0
C
C     --- ASSIGN MATRIX ELEMENTS (R,R1 OPTION)
      HEL(1) = -2.0
      HEL(2) = -1.0
      HEL(3) =  0.0
      HEL(4) =  1.0
      HEL(5) =  2.0
C
      NHEL = 5
C
C
  600 CONTINUE
      RETURN
 6200 FORMAT(A1,I1,1X,I2,5X,6F10.5)
 6300 FORMAT(////1X,'*RD061* ERROR ... Invalid matrix element code was s
     $pecified.')
 6500 FORMAT(////1X,'*RD061* ERROR ... Invalid range of possible matrix
     $elements was specified.')
      END
