C----------------------------------------------------------------------
	integer function Len2ind(cell)
C convert a cell length to the nearest entry in the cell length index 
	real cell
C----------------------------------------------------------------------
	include 'size.par'
	real xi
	if (cell .le. 0.) then
	  xi = 1.
	else
          xi = (log(cell) * 30.) - 27.
	endif
	Len2ind = NINT(xi)
	Len2ind = MAX(Len2ind, 1)
	Len2ind = MIN(Len2ind, MAX_CELL)
	RETURN
	END
C----------------------------------------------------------------------
	subroutine ind2Len(ind,cell,mincell,maxcell)
C show the average, minimum and maximum cell length for an 
C entry in the cell length index 
	integer ind
	real cell, minCELL, maxCELL 
C----------------------------------------------------------------------
	include 'size.par'
        CELL = EXP((ind + 27.)/30.)
        minCELL = EXP((ind + 26.499999)/30.)
        maxCELL = EXP((ind + 27.5)/30.)
	IF (ind .le. 1) mincell = 0.0
	IF (ind .ge. MAX_CELL) maxcell = 9999.0
	RETURN
	END
C----------------------------------------------------------------------
	integer function ang2ind(angle)
C convert a cell angle to the nearest entry in the cell angle index 
	real angle
C----------------------------------------------------------------------
	include 'size.par'
	real xi
        if (ANGLE .GE. 90) THEN
           xi = 28. + 5. * SQRT(ANGLE - 90.)
        else
           xi = 28. - 5. * SQRT(90. - ANGLE)
        endif
	ang2ind = NINT(xi)
	ang2ind = MAX(ang2ind, 1)
	ang2ind = MIN(ang2ind, MAX_ANG)
	RETURN
	END
C----------------------------------------------------------------------
	subroutine ind2ang(ind,ang,minang,maxang)
C show the average, minimum and maximum ang length for an 
C entry in the ang length index 
	integer ind
	real ang, minANG, maxANG 
C----------------------------------------------------------------------
	include 'size.par'

	IF (ind .le. 1) ind = 1
	IF (ind .ge. MAX_ANG) ind = MAX_ANG
        if (ind .eq. 28) THEN
           ang = 90.
           minANG = 90. - (0.5/5.)**2
           maxANG = 90. + (0.5/5.)**2
        elseif (ind .gt. 28) THEN
           ang = 90. + ((ind - 28.)/5.)**2
           minANG = 90. + ((ind - 28.5)/5.)**2
           maxANG = 90. + ((ind - 27.5)/5.)**2
        else
           ang = 90. - ((ind - 28.)/5.)**2
           minANG = 90. - ((ind - 28.5)/5.)**2
           maxANG = 90. - ((ind - 27.5)/5.)**2
        endif
        minang = max(60.,minang)
        maxang = min(120.,maxang)
	RETURN
	END
C----------------------------------------------------------------------
	integer function Rat2ind(ratio,itype)
C convert a cell length ratio to the nearest entry in the cell ratio index 
	real ratio
	integer itype
C----------------------------------------------------------------------
	include 'size.par'
	integer MAXRAT             ! = Maximum ratio index
	real xi
	MAXRAT = MAXRAT_2
	if (itype .eq. 1) MAXRAT = MAXRAT_1
	if (ratio .le. 1.0) then
	   xi = 20. * ratio**2
	else
	   xi = 20 + (20. * log10(ratio))
	endif
	Rat2ind = NINT(xi)
	Rat2ind = MAX(Rat2ind, 1)
	Rat2ind = MIN(Rat2ind, MAXRAT)
	RETURN
	END
C----------------------------------------------------------------------
	subroutine ind2rat(ind,ratio,minratio,maxratio,itype)
C show the average, minimum and maximum cell length ratio for an 
C entry in the cell length index 
	integer ind,itype
	real cell, minratio, maxratio 
C----------------------------------------------------------------------
	include 'size.par'
	integer MAXRAT
	MAXRAT = MAXRAT_2
	if (itype .eq. 1) MAXRAT = MAXRAT_1
	IF (ind .eq. 1) then
	   minratio = 0.
	   maxratio = sqrt((ind+.5)/20.)
	   RATIO = sqrt(ind/20.)
	ELSEIF (ind .lt. 20) then
	   minratio = sqrt((ind-.5)/20.)
	   maxratio = sqrt((ind+.5)/20.)
	   RATIO = (minratio + maxratio) / 2.
	ELSEIF (ind .eq. 20) then
	   minratio = sqrt((ind-.5)/20.)
	   maxratio =  10. ** ((ind - 19.5) / 20.)
	   RATIO = (minratio + maxratio) / 2.
	ELSEIF (ind .eq. MAXRAT) then
	   minratio = 10. ** ((ind - 20.5) / 20.)
	   maxratio =  999.
	   ratio =  10. ** ((ind - 20.) / 20.)
	ELSE
	   minratio = 10. ** ((ind - 20.5) / 20.)
	   maxratio =  10. ** ((ind - 19.5) / 20.)
	   RATIO = (minratio + maxratio) / 2.
	ENDIF
	RETURN
	END
