C========================================================================
C========================================================================
C
C Program to combine NIST Crystal Data Database searches
C
C========================================================================
C input line 1: list of required elements by number
C       line 2: opt mode = 0 = all optional
C                        = 1 = specific elements allowed
C       line 3: list of allowed elements by number (mode = 1)
C========================================================================
      IMPLICIT NONE

      include 'size.par'
      include 'map.cmn'
      include 'cdf.cmn'
      include 'cdfread.def'
      include 'bitops.def'

      INTEGER IARGC,STATUS,mode
      integer FLAG,ilogic
      INTEGER I,I1,I2,J,NARG,LENCH,k
      integer psl_readbitmap
      integer psl_savebitmap
      CHARACTER*256 INFILE,OUTFILE
      CHARACTER*100 trace

      INFILE = ' '
      OUTFILE = ' '
C initialize the database
      call ps_CDinit(STATUS)
      IF (STATUS .ne. 0) STOP 'Error in CDINIT'
      NARG = IARGC()
      IF (NARG .GE. 1) THEN
         CALL GETARG(1,OUTFILE)
      ENDIF
      IF (outfile .eq. ' ') THEN
         write (*,*) 'No output file'
         stop 1
      ENDIF
      flag = 0
C read files to OR together
      read(*,'(i3,1x,a)') ilogic,infile 
      do while (infile .ne. ' ') 
         if (flag .eq. 0) THEN
            call psl_mapinit(0)
            flag = 1
         ENDIF
         if (ilogic .eq. 0) then 
            STATUS = psl_readbitmap(infile,1)
         else
            STATUS = psl_readbitmap(infile,3)
         endif
         read(*,'(i3,1x,a)') ilogic,infile 
      ENDDO

C read files to AND together
      read(*,'(i3,1x,a)') ilogic,infile 
      do while (infile .ne. ' ') 
         if (flag .eq. 0) THEN
            call psl_mapinit(1)
            flag = 1
         ENDIF
         if (ilogic .eq. 0) then 
            STATUS = psl_readbitmap(infile,0)
         else
            STATUS = psl_readbitmap(infile,2)
         endif
         read(*,'(i3,1x,a)') ilogic,infile 
      ENDDO

      nphase = TBLCOUNT(TABLE,N_Cards)
      WRITE(*,*) 'Found ',nphase,' entries'
      STATUS = psl_savebitmap(outfile)
      if (STATUS .ne. 0) stop 1
      WRITE (*,*) 'Writing ',outfile(:lench(outfile))
      STOP
      END
