C========================================================================
C========================================================================
C
C Program to search the NIST Crystal Data Database by element count
C
C========================================================================
C========================================================================
      IMPLICIT NONE

      include 'size.par'
      include 'map.cmn'
      include 'cdf.cmn'
      include 'cdfread.def'
      include 'bitops.def'

      INTEGER IARGC,STATUS
      INTEGER I,I1,I2,NARG,LENCH,k
      integer psl_readbitmap
      integer psl_savebitmap
      CHARACTER*256 INFILE,OUTFILE
      CHARACTER*100 trace

      INFILE = ' '
      OUTFILE = ' '
C initialize the database
      call ps_CDinit(STATUS)
      call psl_mapinit(1)
      IF (STATUS .ne. 0) STOP 'Error in CDINIT'
      NARG = IARGC()
      IF (NARG .GE. 1) THEN
         CALL GETARG(1,OUTFILE)
      ENDIF
      IF (NARG .GE. 2) THEN
         CALL GETARG(2,INFILE)
      ENDIF
      IF (outfile .eq. ' ') THEN
         write (*,*) 'No output file'
         stop 1
      ENDIF
      IF (infile .ne. ' ') THEN
         STATUS = psl_readbitmap(infile,-1)
         if (STATUS .ne. 0) stop 1
         WRITE (*,*) 'Reading: ',infile(:lench(infile))
      ENDIF
      I1 = 0
      I2 = 0
      READ (*,*,end=1) I1,I2 
 1    CALL ps_openelemcnt(STATUS)
      IF (status .ne. 0) THEN
	 WRITE (*,*) 'Unable to open element count bitmap file'
	 STOP 1
      ENDIF
      IF (I2 .EQ. 0) I2 = I1
      nph1 = TBLCLR(TABLE1,N_Cards)
      DO I=MAX(I1,1),MIN(I2,max_ELEMC)
         k = ps_readbitlib(i, table2, N_cards)
         IF (k .ne. 0) THEN
            WRITE (*,*) 'Error reading element count bitmap file'
            STOP 1
         ENDIF
         CALL TBLOR(TABLE1,TABLE2,TABLE1,N_Cards)
      ENDDO
      call ps_closebitlib()
C========================================================================
C now setup the history entry
C========================================================================
      IF (I2 .eq. I1) Then
         Write (trace,'(A,I2)') 'Element Count =',I1
      ELSE
         Write (trace,'(A,I2,A,I2)') 'Element Count =',I1,' to',I2
      ENDIF
      CALL TBLLOGIC(0, trace)
      nphase = TBLCOUNT(TABLE,N_Cards)
      WRITE(*,*) 'Found ',nphase,' entries'
      STATUS = psl_savebitmap(outfile)
      if (STATUS .ne. 0) stop 1
      WRITE (*,*) 'Writing ',outfile(:lench(outfile))
      STOP
      END

