/* test program to read a cell */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void getjournal(const char * coden, char * journal, FILE * inorgFP, FILE * orgFP) {
    char line[128];
    char *inp;

    /* Prepare a result incase we don't find a match */
    strcpy(journal, coden);

    if (inorgFP != NULL) {
      fseek(inorgFP, 0, SEEK_SET);
      
      inp = fgets(line, 128, inorgFP); 
      while (memcmp(coden, line,6) != 0 && inp != 0) {
	inp = fgets(line, 128, inorgFP); 
      }
      if (inp != 0) {
	size_t i;
	strcpy(journal, line+7);
	/* eliminate trailing blanks and non-printables */
	for (i = strlen(journal); i > 0; i--) {
	  if (journal[i] > ' ') break;
	  journal[i] = 0;
	}
	return;
      }
    }

    if (orgFP != NULL) {
      fseek(orgFP, 0, SEEK_SET);
      
      inp = fgets(line, 128, orgFP); 
      while (memcmp(coden, line,6) != 0 && inp != 0) {
	inp = fgets(line, 128, orgFP); 
      }
      if (inp != 0) {
	size_t i;
	strcpy(journal, line+7);
	/* eliminate trailing blanks and non-printables */
	for (i = strlen(journal); i > 0; i--) {
	  if (journal[i] > ' ') break;
	  journal[i] = 0;
	}
	return;
      }
    }
    return;
}

int main (int argc, char ** argv) {
  char inpath[128];
  char outpath[128];
  FILE * idind;
  long iseq,id,pos;
  int mode;

  if (argc == 2) 
    {
      sscanf(argv[1], "%ld", &iseq); 
      mode = 1;
    }
  else if (argc == 3) 
    {
      sscanf(argv[2], "%ld", &iseq); 
      mode = 2;
    }
  else 
    {
      fputs("Useage \n\tgetcell [-f] <seq>\n", stderr);
      return 1;
    }
  
  /*  get the location for the data files */
  {
    FILE * filep;
    filep = fopen("cd_file_location", "r");
    if (filep == NULL) return 1;
    if (fscanf(filep, "%s", inpath) != 1) /* location of cdrom files */
      return 2;
    if (fscanf(filep, "%s", outpath) != 1) /* location of disk files */
      return 3;
    fclose(filep);
  }

  /* Adjust the sequence number to start at 0 */
  iseq--;

  if (mode == 1) {
    /*  get the id number */
    {
      char tempname[128];
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-id");
      idind = fopen(tempname, "r");
      if (idind == NULL) return 4;
      fseek(idind, 4 * iseq, SEEK_SET);
      fread(&id, 4, 1,  idind); 
      fclose(idind);
    }
    /* printf ("<TD>%ld</TD>\n", id); */
    

    printf ("<TD><FONT SIZE=-1>");
    /*  Get the reduced cell  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-reduced-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-reduced-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      {
	int i;
	float a,b,c,d,e,f;
	sscanf(line, "%d%f%f%f%f%f%f",&i,&a,&b,&c,&d,&e,&f);
	printf ("%5.3f, %5.3f, %5.3f, %5.2f, %5.2f, %5.2f",a,b,c,d,e,f);
      }
      fclose(cdind);
    }

    printf ("<BR>");

  /*  Get the crystal data cell  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      float a,b,c,d,e,f;
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-CrystalData-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-CrystalData-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      {
	int i;
	sscanf(line, "%d%f%f%f%f%f%f",&i,&a,&b,&c,&d,&e,&f);
	printf ("%5.3f, %5.3f, %5.3f, %5.2f, %5.2f, %5.2f",a,b,c,d,e,f);
      }
      fclose(cdind);
    }

    printf ("</FONT></TD>\n");

    printf ("<TD>");
    /* get the names */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char fullname[128];
      char *inp;
      long cdid;
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-compound-name");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-compound-name");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      inp = fgets(line, 128, cdind); 
      sscanf(line, "%ld", &cdid); 
      fullname[0] = 0;
      while (cdid == id && inp != 0) {
	size_t i;
	for (i = strlen(line); i > 12 ; i--) {
	  if (line[i] > ' ') break;
	  line[i] = 0;
	}
	/*        if (fullname[0] != 0) strcat(fullname, " / "); */
	if (fullname[0] != 0) strcat(fullname, "<BR>");
	strcat(fullname, line+12);
	inp = fgets(line, 128, cdind); 
	sscanf(line, "%ld", &cdid); 
      }
      printf ("%s", fullname);
      fclose(cdind);
    }

    printf ("<BR>");
    /*  Get the chemical formula */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      size_t i;

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-chemical-formula");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      if (pos < 0) return 0;

      strcpy(tempname,inpath);
      strcat(tempname, "cd-chemical-formula");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      for (i = strlen(line); i > 14 ; i--) {
	if (line[i] > ' ') break;
	line[i] = 0;
      }
      printf ("%s", line+14);
      fclose(cdind);
    }

    printf ("</TD>\n");

    printf ("<TD>");
    /*  Get the CD spacegroup  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-CrystalData-parameters-II");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-CrystalData-parameters-II");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      line[18]=0;
      line[24]=0;
      line[35]=0;
      line[79]=0;
      if (line[23] == '0') {
	printf ("&nbsp;</TD><TD>%s<BR>Z=%s",line+70,line+30);
      } else {
	printf ("%s<BR>(%s)</TD><TD>%s<BR>Z=%s",line+10,line+21,line+70,line+30);
      }
      fclose(cdind);
    }
    printf ("</TD>\n");

   /*  Show the year */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char *inp;
      long cdid;

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-literature-reference");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      if (pos < 0) return 0;

      strcpy(tempname,inpath);
      strcat(tempname, "cd-literature-reference");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      inp =fgets(line, 128, cdind); 
      sscanf(line, "%ld", &cdid); 
      if (cdid == id && inp != 0) {
	char year[5];
	year[4] = 0;
	memcpy(year,line+32,4);
	printf ("<TD>%s</TD>\n",year);
	inp = fgets(line, 128, cdind); 
	sscanf(line, "%ld", &cdid); 
      }
      fclose(cdind);
    }

  } else {
    /* ========================================================================= */
    /* ======= long display ==================================================== */
    /* ========================================================================= */
    int metricX = 0;
    FILE * inorgFP, * orgFP;
    char tempname[128];
    strcpy(tempname,inpath);
    strcat(tempname, "codens-inorganic");
    inorgFP = fopen(tempname, "r");
    strcpy(tempname,inpath);
    strcat(tempname, "codens-organic");
    orgFP = fopen(tempname, "r");

    printf ("<TABLE>\n");
    {
      /*  get the id number */
      char tempname[128];
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-id");
      idind = fopen(tempname, "r");
      if (idind == NULL) return 4;
      fseek(idind, 4 * iseq, SEEK_SET);
      fread(&id, 4, 1,  idind); 
      fclose(idind);
    }
    printf ("<TR><TD>Crystal Data Id #</TD><TD>%ld</TD></TR>\n", id);

    /*  Get the CD spacegroup  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-CrystalData-parameters-II");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-CrystalData-parameters-II");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      line[18]=0;
      line[24]=0;
      line[35]=0;
      line[79]=0;
      if (line[22] != ' ' || line[23] != '0') {
	printf ("<TR><TD>Space Group</TD><TD>%s (#%s)</TD></TR>\n",line+10,line+21);
      }
      if (line[34] != ' ') {
	printf ("<TR><TD>Z</TD><TD>%s</TD></TR>\n",line+30);
      }
      printf ("<TR><TD>Cell Volume</TD><TD>%s</TD></TR>\n",line+70);
      fclose(cdind);
    }

    /* show the names */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char *inp;
      long cdid;
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-compound-name");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-compound-name");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      inp = fgets(line, 128, cdind); 
      sscanf(line, "%ld", &cdid); 
      while (cdid == id && inp != 0) {
	size_t i;
	for (i = strlen(line); i > 12 ; i--) {
	  if (line[i] > ' ') break;
	  line[i] = 0;
	}
	if (line[10] == ' ') {
	  printf ("<TR><TD>CD Index name</TD>");
	  printf ("<TD>%s</TD></TR>\n", line+12);
	} else if (line[10] == 'N') {
	  printf ("<TR><TD>Chemical name</TD>");
	  printf ("<TD>%s</TD></TR>\n", line+12);
	} else if (line[10] == 'M') {
	  printf ("<TR><TD>Mineral name</TD>");
	  printf ("<TD>%s</TD></TR>\n", line+12);
	} else if (line[10] == 'C') {
	  printf ("<TR><TD>Common name</TD>");
	  printf ("<TD>%s</TD></TR>\n", line+12);
	}
	inp = fgets(line, 128, cdind); 
	sscanf(line, "%ld", &cdid); 
      }
      fclose(cdind);
    }
    printf ("</TR>\n");

    /*  Show the chemical formula */
    printf ("<TR><TD>Chemical formula</TD>");
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      size_t i;

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-chemical-formula");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      if (pos < 0) return 0;

      strcpy(tempname,inpath);
      strcat(tempname, "cd-chemical-formula");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      for (i = strlen(line); i > 14 ; i--) {
	if (line[i] > ' ') break;
	line[i] = 0;
      }
      printf ("<TD>%s</TD>", line+14);
      fclose(cdind);
    }
    printf ("</TR>\n");

   /*  Show the literature reference */
    printf ("<TR><TD>Reference</TD>");
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      size_t i;
      char *inp;
      long cdid;

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-literature-reference");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      if (pos < 0) return 0;

      strcpy(tempname,inpath);
      strcat(tempname, "cd-literature-reference");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      inp =fgets(line, 128, cdind); 
      sscanf(line, "%ld", &cdid); 
      i = 0;
      while (cdid == id && inp != 0) {
	int ln;
	char coden[7],volume[5],page[6],year[5];
	char journal[128];
	i++;
	if (i > 1) printf("<BR>");
	coden[6] = volume[4] = page[5] = year[4] = 0;
	memcpy(coden,line+14,6);
	memcpy(volume,line+21,4);
	memcpy(page,line+26,5);
	memcpy(year,line+32,4);
	getjournal(coden,journal,inorgFP,orgFP);
	/* Are there any authors listed */
	ln = 0;
	for (i = 126; i > 37; i--) {
	  if (line[i] <= ' ') {
	    line[i] = 0;
	  } else {
	    ln = i - 37;
	    break;
	  }
	}
	if (ln > 0) {
	  printf ("<TD>%s, %s <B>%s</B> (%s), %s</TD>\n",
		  line+37,journal,volume,year,page);
	} else {
	  printf ("<TD>%s, <B>%s</B> (%s), %s</TD>\n",journal,volume,year,page);
	}
	inp = fgets(line, 128, cdind); 
	sscanf(line, "%ld", &cdid); 
      }
      fclose(cdind);
    }
    printf ("</TR>\n");
    
    printf ("</TABLE>\n");
    printf ("<TABLE><TR><TD>Reduced cell</TD>");
    /*  Get the reduced cell  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char l[10];
      int i,j;

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-reduced-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-reduced-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      if (line[77] == 'X') metricX = 1;
      j = 10;
      for (i = 0; i < 3; i++) {
	memcpy(l,line+j,8);
	l[8] = 0;
	printf ("<TD>%s</TD>",l);
	j += 8;
      }
      for (i = 3; i < 6; i++) {
	memcpy(l,line+j,7);
	l[7] = 0;
	printf ("<TD>%s</TD>",l);
	j += 7;
      }
      fclose(cdind);
    }

    printf ("</TR>\n");
    printf ("<TR><TD>Crystal Data cell</TD>");

  /*  Get the crystal data cell  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char l[10];
      int i,j;
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-CrystalData-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-CrystalData-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      j = 10;
      for (i = 0; i < 3; i++) {
	memcpy(l,line+j,8);
	l[8] = 0;
	printf ("<TD>%s</TD>",l);
	j += 8;
      }
      for (i = 3; i < 6; i++) {
	memcpy(l,line+j,7);
	l[7] = 0;
	printf ("<TD>%s</TD>",l);
	j += 7;
      }
      fclose(cdind);
    }
    printf ("</TR>\n");
    printf ("<TR><TD>Author's cell</TD>");

    /*  Get the authors cell  */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      char l[10];
      int i,j;
      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-authors-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      strcpy(tempname,inpath);
      strcat(tempname, "cd-authors-parameters-I");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 6;
      fseek(cdind, pos, SEEK_SET);
      fgets(line, 128, cdind); 
      j = 10;
      for (i = 0; i < 3; i++) {
	memcpy(l,line+j,9);
	l[9] = 0;
	printf ("<TD>%s</TD>",l);
	j += 9;
      }
      j++;
      for (i = 3; i < 5; i++) {
	memcpy(l,line+j,8);
	l[8] = 0;
	printf ("<TD>%s</TD>",l);
	j += 8;
      }
      memcpy(l,line+j,7);
      l[7] = 0;
      printf ("<TD>%s</TD>",l);
      fclose(cdind);
    }
    printf ("</TR>\n");
    printf ("</TABLE>\n");

    /*  Show comments, if any */
    {
      FILE * cdind;
      char line[128];
      char tempname[128];
      size_t i,j;
      char *inp;
      long cdid;

      j = 0;
      if (metricX == 1) {
	printf("<H4>Comments</H4><UL>");
	printf("Cell metric symmetry exceeds crystallographic symmetry\n");
	j++;
      }

      strcpy(tempname,outpath);
      strcat(tempname, "IND_cd-comments");
      cdind = fopen(tempname, "r");
      if (cdind == NULL) return 5;
      fseek(cdind, 4 * iseq, SEEK_SET);
      fread(&pos, 4, 1,  cdind); 
      fclose(cdind);

      if (pos >= 0) {
	strcpy(tempname,inpath);
	strcat(tempname, "cd-comments");
	cdind = fopen(tempname, "r");
	if (cdind == NULL) return 6;
	fseek(cdind, pos, SEEK_SET);
	inp =fgets(line, 128, cdind); 
	sscanf(line, "%ld", &cdid); 
	while (cdid == id && inp != 0) {
	  /* Skip some ICDD-type comments */
	  if (line[11] == 'A' && line[12] == 'D') break;
	  if (line[11] == 'L' && line[12] == 'N') break;
	  if (line[11] == 'H' && line[12] == 'K') break;
	  if (line[11] == 'F' && line[12] == 'N') break;
	  if (line[11] == 'F' && line[12] == 'F') break;
	  j++;
	  if (j == 1) printf("<H4>Comments</H4><UL>");
	  if (j > 1) printf("<BR>");
	  for (i = 126; i > 14; i--) {
	    if (line[i] <= ' ') {
	      line[i] = 0;
	    } else {
	      break;
	    }
	  }
	  if (line[11] == 'C' && line[12] == 'L') printf ("Color: ");
	  if (line[11] == 'S' && line[12] == 'T') printf ("Structure: ");
	  if (line[11] == 'O' && line[12] == 'P') printf ("Optical Data: ");
	  if (line[11] == 'P' && line[12] == 'M') printf ("Polymorphism: "); 
	  if (line[11] == 'M' && line[12] == 'P') printf ("Melting point: ");
	  if (line[11] == 'C' && line[12] == 'R') printf ("Cross reference: ");
	  if (line[11] == 'O' && line[12] == 'O') printf ("ICDD quality O: "); 
	  if (line[11] == 'D' && line[12] == 'B') printf ("ICDD delete ref: "); 
	  printf ("%s\n",line+14);
	  inp = fgets(line, 128, cdind); 
	  sscanf(line, "%ld", &cdid); 
	}
	fclose(cdind);
      }
      if (j != 0) printf("</UL>\n");
    }
  }

  return 0;
}

