      include 'copyrght.def'
C
      integer function psl_savebitmap(filename)
C save the contents of the current bitmap to a file
C-----------------------------------------------------------------------
      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_savebitmap
      character*80 filename
!      integer overwrite
!C overwrite is 1 if overwriting of an existing file is allowed
C-----------------------------------------------------------------------
      include 'cdfread.def'

      include 'size.par'
      
      include 'cdf.cmn'
      include 'map.cmn'

C-----------------------------------------------------------------------
      integer ln,i,cln
      integer lench

      ln = lench(filename)
      filename(ln+1:ln+1) = char(0)
      cln = context_length
      i = ps_writemap(filename,N_cards,table,cnum,context,cln)
      if (i .ne. 0) then
         psl_savebitmap = -1
         call warnmsg('savebitmap','unable to open/write file '//
     $        filename(:ln))
         call errcode('savebitmap',i)
         return
      endif
      psl_savebitmap = 0
      return
      end
C-----------------------------------------------------------------------
      integer function psl_readbitmap(filename,ilogic)
C read the contents of a saved bitmap from a file
C-----------------------------------------------------------------------
      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_readbitmap
      character*80 filename
      integer ilogic
C ilogic determines the logic to be applied to the tables
C	-1	 Load file as current table
C	0	 Match with table (AND <file>)
C	1	 Add to table (OR <file>)
C	2	 Remove from table (AND NOT <file>)
C	3	 File without current table (OR NOT <file))
C-----------------------------------------------------------------------
      include 'cdfread.def'

      include 'size.par'
      
      include 'cdf.cmn'
      include 'map.cmn'

      integer ln,i,j
      integer lench

      INTEGER*4 tcnum, cln
      CHARACTER*(context_length) tCONTEXT(cnum_max)

      ln = lench(filename)
      filename(ln+1:ln+1) = char(0)
      cln = context_length
      i = ps_readmap(filename,j,table1,tcnum,tcontext,cln)
      if (i .ne. 0) then
         psl_readbitmap = -1
         call warnmsg('readbitmap','unable to open/read file '//
     $        filename(:ln))
         call errcode('readbitmap',i)
         return
      endif
      if (j .ne. N_cards) then
         psl_readbitmap = -2
         call warnmsg('readbitmap','bitmap on file '//
     $        filename(:ln)//
     $        ' has a different size than current database')
         return
      endif
      if (ilogic .lt. 0) then
         cnum = tcnum
         do i=1,cnum
            context(i) = tcontext(i)
         enddo
         call tblcopy(table1, table, N_cards) 
      else
         call tbllogic(ilogic,'previous search (below)')
!         call tbllogic(ilogic,'search on file ('//filename(:ln)//')')
         do i=1,tcnum
            context(i+cnum) = '... '//tcontext(i)
         enddo
         cnum = cnum + tcnum
      endif

      psl_readbitmap = 0
      return
      end
C-----------------------------------------------------------------------
      integer function psl_mapinit(ilogic)
C initialize the bitmap
C-----------------------------------------------------------------------
      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_mapinit
      integer ilogic
C ilogic determines the logic to be applied to the tables
C	0	 No Entries
C	1	 All Entries
C-----------------------------------------------------------------------
      include 'bitops.def'

      include 'size.par'
      
      include 'cdf.cmn'
      include 'map.cmn'

      if (ilogic .eq. 0) then
         nphase = tblclr(table, N_cards)
         cnum = 1
         context(1) = 'Starting with no entries'
      else
         nphase = tblset(table, N_cards)
         cnum = 1
         context(1) = 'Starting from full database'
      endif
      psl_mapinit = 0
      return
      end
