C========================================================================
C========================================================================
C
C Program to search the NIST Crystal Data Database by misc bitmap records
C
C========================================================================
C input: list of record number(s)

C note that if more that one record number is specified, the records will
C be ORed together
C========================================================================
      IMPLICIT NONE

      include 'size.par'
      include 'map.cmn'
      include 'cdf.cmn'
      include 'cdfread.def'
      include 'bitops.def'

      INTEGER IARGC,STATUS
      INTEGER I,NARG,LENCH,k
      INTEGER N,IREC
      integer psl_readbitmap
      integer psl_savebitmap
      CHARACTER*256 INFILE,OUTFILE
      CHARACTER*300 trace
      CHARACTER*30 MISCLBL(21)/
     $     'Inorganic','Organic','Minerals','Alloys',
     $     'x-ray cell','neutron cell', 'TEM cell','gamma cell',
     $     'Single xtal cell','Powder peaks cell',
     $     'Rietveld cell',
     $     'Structure not det.','Partial structure det.',
     $     'Complete structure det.',
     $     'Triclinic','Monoclinic','Orthorhombic','Rhombohedral',
     $     'Tetragonal','Hexagonal','Cubic'/

      INFILE = ' '
      OUTFILE = ' '
C initialize the database
      call ps_CDinit(STATUS)
      call psl_mapinit(1)
      IF (STATUS .ne. 0) STOP 'Error in CDINIT'
      NARG = IARGC()
      IF (NARG .GE. 1) THEN
         CALL GETARG(1,OUTFILE)
      ENDIF
      IF (NARG .GE. 2) THEN
         CALL GETARG(2,INFILE)
      ENDIF
      IF (outfile .eq. ' ') THEN
         write (*,*) 'No output file'
         stop 1
      ENDIF
      IF (infile .ne. ' ') THEN
         STATUS = psl_readbitmap(infile,-1)
         if (STATUS .ne. 0) stop 1
         WRITE (*,*) 'Reading: ',infile(:lench(infile))
      ENDIF

      CALL ps_openmisc(STATUS)
      IF (status .ne. 0) THEN
	 WRITE (*,*) 'Unable to open misc bitmap file'
	 STOP 1
      ENDIF

      nph1 = TBLCLR(TABLE1,N_Cards)
      trace = ' '
      N = 0
      DO I=1,999
         READ (*,*,end=1) irec
         if (irec .le. 0) goto 1
         k = ps_readbitlib(irec, table2, N_cards)
         IF (k .ne. 0) THEN
            WRITE (*,*) 'Error reading bitmap file'
            STOP 1
         ENDIF
         n = n + 1
         if (n .eq. 1) then
            trace(lench(trace)+1:) = '"'//MISCLBL(irec)
         else
            trace(lench(trace)+1:) = ' + "'//MISCLBL(irec)
         endif
         trace(lench(trace)+1:) = '"'
         CALL TBLOR(TABLE1,TABLE2,TABLE1,N_Cards)
      ENDDO
 1    call ps_closebitlib()
      if (n .eq. 1) then
         trace(lench(trace)+1:) = ' subfile'
      else
         trace(lench(trace)+1:) = ' subfiles'
      endif

      CALL TBLLOGIC(0, trace)
      nphase = TBLCOUNT(TABLE,N_Cards)
      WRITE(*,*) 'Found ',nphase,' entries'
      STATUS = psl_savebitmap(outfile)
      if (STATUS .ne. 0) stop 1
      WRITE (*,*) 'Writing ',outfile(:lench(outfile))
      STOP
      END

