C========================================================================
C========================================================================
C
C Program to search the NIST Crystal Data Database by cell ratios
C 
C
C========================================================================
C input line 1: ratio number (1 or 2)
C       line 2: min ratio, max ratio
C========================================================================
      IMPLICIT NONE

      include 'size.par'
      include 'map.cmn'
      include 'cdf.cmn'
      include 'cdfread.def'
      include 'bitops.def'

      INTEGER IARGC,STATUS
      INTEGER I,I1,I2,J,NARG,LENCH,k,itype
      integer psl_readbitmap
      integer psl_savebitmap
      CHARACTER*256 INFILE,OUTFILE
      CHARACTER*100 trace
      REAL ratmin,ratmax,x1,x2
      integer rat2ind


      INFILE = ' '
      OUTFILE = ' '
C initialize the database
      call ps_CDinit(STATUS)
      call psl_mapinit(1)
      IF (STATUS .ne. 0) STOP 'Error in CDINIT'
      NARG = IARGC()
      IF (NARG .GE. 1) THEN
         CALL GETARG(1,OUTFILE)
      ENDIF
      IF (NARG .GE. 2) THEN
         CALL GETARG(2,INFILE)
      ENDIF
      IF (outfile .eq. ' ') THEN
         write (*,*) 'No output file'
         stop 1
      ENDIF
      IF (infile .ne. ' ') THEN
         STATUS = psl_readbitmap(infile,-1)
         if (STATUS .ne. 0) stop 1
         WRITE (*,*) 'Reading: ',infile(:lench(infile))
      ENDIF
      I1 = 0
      I2 = 0
C cell
      itype = 0
      ratmin = 0
      ratmax = 0
      READ (*,'(A)',end=1) trace
      read (trace,*,end=1) itype
C errors
 1    READ (*,'(A)',end=2) trace
      read (trace,*,end=2) ratmin,ratmax

 2    if (itype .eq. 1 .or. itype .eq. 2) then
         CALL ps_Openratio(itype,STATUS)
      else
         WRITE (*,*) 'Invalid value, ',itype,', for ratio type'
         STOP 1
      endif
C     convert length to index numbers 
      if (ratmax .eq. 0) ratmax = ratmin
      i1 = Rat2ind(min(ratmin,ratmax),itype)
      i2 = Rat2ind(max(ratmin,ratmax),itype)

      nph2 = TBLCLR(TABLE1,N_Cards)
      DO j=i1,i2
         k = ps_readbitlib(j, table2, N_cards)
         CALL TBLOR(TABLE1,TABLE2,TABLE1,N_Cards)
      enddo
      call ps_closebitlib()
C========================================================================
C now setup the history entry
C========================================================================
      Call ind2Rat(i1,x1,ratmin,x2,itype)
      Call ind2Rat(i2,x1,x2,ratmax,itype)
      write(trace,'(A,i1,a,f6.2,a,f6.2)')
     $     'Cell ratio #',itype,' search: from ',ratmin,' to',ratmax
      CALL TBLLOGIC(0, trace)
      nphase = TBLCOUNT(TABLE,N_Cards)
      WRITE(*,*) 'Found ',nphase,' entries'
      STATUS = psl_savebitmap(outfile)
      if (STATUS .ne. 0) stop 1
      WRITE (*,*) 'Writing ',outfile(:lench(outfile))
      STOP
      END

