C========================================================================
C========================================================================
C
C Program to show the contents of a saved map
C
C========================================================================
C========================================================================
      IMPLICIT NONE

      include 'size.par'
      include 'map.cmn'
      include 'cdf.cmn'
      include 'cdfread.def'
      include 'bitops.def'

      INTEGER IARGC,STATUS
      INTEGER I,J,LN,NARG,iseq,LENCH
      integer*4 id
      integer psl_readbitmap
      CHARACTER*2 arg
      CHARACTER*256 INFILE

      INFILE = ' '
C initialize the database
      call ps_CDinit(STATUS)
      call psl_mapinit(1)
      IF (STATUS .ne. 0) STOP 'Error in CDINIT'
      NARG = IARGC()
      IF (NARG .EQ. 1) THEN
         CALL GETARG(1,INFILE)
         arg = '-h'
      ELSE
         CALL GETARG(1,arg)
         CALL GETARG(2,INFILE)
      ENDIF
      IF (infile .eq. ' ') THEN
         write (*,*) 'No input file'
         stop 1
      ENDIF
      STATUS = psl_readbitmap(infile,-1)
      if (STATUS .ne. 0) stop 1
      if (arg .eq. '-s') then
         iseq = 0
         do I=1,N_cards
            iseq = iseq + 1
            IF (TABLE(1 + (I-1)/32) .NE. 0) then 
               if (tblbittest(TABLE,i,N_cards) .eq. 1)
     $              write (*,*) iseq
            ENDIF
         ENDDO
      elseif (arg .eq. '-i') then
C     Open the id index
         OPEN(UNIT=1,STATUS='OLD',err=1000,
	1    ACCESS='DIRECT',RECL=4,FORM='UNFORMATTED',
	1    FILE=dbloc(:lench(dbloc))//'IND_cd-id')
         iseq = 0
         do I=1,N_cards
            iseq = iseq + 1
            IF (TABLE(1 + (I-1)/32) .NE. 0) then 
               if (tblbittest(TABLE,i,N_cards) .eq. 1) then
                  READ(1,rec=ISEQ) ID
                  write (*,*) id
               ENDIF
            ENDIF
         ENDDO
      elseif (arg .eq. '-n') then
         nphase = TBLCOUNT(TABLE,N_Cards)
         WRITE(*,*) nphase,' entries'
      elseif (arg .eq. '-h' .or. arg .eq. '-H') then
C         WRITE(*,*) 'History:'
         DO I=1,CNUM
            ln = lench(context(i))
            if (ln .gt. 50) then
               ln = 50
               DO J=50,35,-1
                  IF (context(I)(J:J).EQ.' ' .OR.
     $                 context(I)(J:J).EQ.',') THEN
                     LN = J
                     GOTO 1
                  ENDIF
               ENDDO
 1             WRITE (*,'(i3,1x,A)') I,context(I)(:LN)//' -'
               if (arg .eq. '-H')  WRITE (*,*) '<BR>'
               context(I) = context(I)(LN+1:)
               ln = lench(context(i))
            ELSE
               WRITE (*,'(i3,1x,A)') I,context(I)(:LN)
               if (arg .eq. '-H')  WRITE (*,*) '<BR>'
               ln = 0
            ENDIF
            DO WHILE (LN .GT. 0)
               if (ln .lt. 50) then
                  if (arg .eq. '-H')
     $                 WRITE (*,*) '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                  WRITE (*,'(6x,A)') context(I)(:LN)
                  if (arg .eq. '-H')  WRITE (*,*) '<BR>'
                  LN = 0
               ELSE
                  LN = 50
                  DO J=50,35,-1
                     IF (context(I)(J:J).EQ.' ' .OR.
     $                    context(I)(J:J).EQ.',') THEN
                        LN = J
                        GOTO 2
                     ENDIF
                  ENDDO
 2                if (arg .eq. '-H')
     $                 WRITE (*,*) '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                  WRITE (*,'(6x,A)') context(I)(:LN)//' - '
                  if (arg .eq. '-H')  WRITE (*,*) '<BR>'
                  context(I) = context(I)(LN+1:)
                  ln = lench(context(i))
               ENDIF
            ENDDO
         ENDDO
      else
         write(*,*) 'Usage: showmap  [arg] <file>'
         write(*,*) '       [arg] = -h  show file header [default]'
         write(*,*) '             = -H  show file header in HTML'
         write(*,*) '             = -n  total number of entries'
         write(*,*) '             = -i  id number of entries'
         write(*,*) '             = -s  list of seq number of entries'
      endif
      STOP
 1000 STOP 'Error opening file IND_cd-id'
      END

